




var _createReactDOMStyle=require('./createReactDOMStyle');var _createReactDOMStyle2=_interopRequireDefault(_createReactDOMStyle);
var _flattenArray=require('../../modules/flattenArray');var _flattenArray2=_interopRequireDefault(_flattenArray);
var _flattenStyle=require('./flattenStyle');var _flattenStyle2=_interopRequireDefault(_flattenStyle);
var _generateCss2=require('./generateCss');var _generateCss3=_interopRequireDefault(_generateCss2);
var _injector=require('./injector');var _injector2=_interopRequireDefault(_injector);
var _mapKeyValue=require('../../modules/mapKeyValue');var _mapKeyValue2=_interopRequireDefault(_mapKeyValue);
var _prefixInlineStyles=require('./prefixInlineStyles');var _prefixInlineStyles2=_interopRequireDefault(_prefixInlineStyles);
var _ReactNativePropRegistry=require('../../modules/ReactNativePropRegistry');var _ReactNativePropRegistry2=_interopRequireDefault(_ReactNativePropRegistry);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}function _defineProperty(obj,key,value){if(key in obj){Object.defineProperty(obj,key,{value:value,enumerable:true,configurable:true,writable:true});}else{obj[key]=value;}return obj;}

var prefix='r';
var SPACE_REGEXP=/\s/g;
var ESCAPE_SELECTOR_CHARS_REGEXP=/[(),":?.%\\$#]/g;




var createClassName=function createClassName(prop,value){
var val=(''+value).replace(SPACE_REGEXP,'-');
return'rn-'+prop+':'+val;
};





var injectedClassNames={};
var injectClassNameIfNeeded=function injectClassNameIfNeeded(prop,value){
var className=createClassName(prop,value);
if(!injectedClassNames[className]){

var selector=className.replace(ESCAPE_SELECTOR_CHARS_REGEXP,'\\$&');
var body=(0,_generateCss3.default)(_defineProperty({},prop,value));
var css='.'+selector+'{'+body+'}';

_injector2.default.addRule(className,css);
injectedClassNames[className]=true;
}

return className;
};




var resolvedPropsCache={};
var registerStyle=function registerStyle(id,flatStyle){
var style=(0,_createReactDOMStyle2.default)(flatStyle);
var className=(0,_mapKeyValue2.default)(style,function(prop,value){
if(value!=null){
return injectClassNameIfNeeded(prop,value);
}
}).join(' ').trim();

var key=''+prefix+id;
resolvedPropsCache[key]={className:className};

return id;
};




var resolveProps=function resolveProps(reactNativeStyle){
var flatStyle=(0,_flattenStyle2.default)(reactNativeStyle);

if(process.env.__REACT_NATIVE_DEBUG_ENABLED__){
console.groupCollapsed('[render] deoptimized: resolving uncached styles');
console.log('source style\n',reactNativeStyle);
console.log('flattened style\n',flatStyle);
}

var domStyle=(0,_createReactDOMStyle2.default)(flatStyle);
var style={};

var _className=(0,_mapKeyValue2.default)(domStyle,function(prop,value){
if(value!=null){
var singleClassName=createClassName(prop,value);
if(injectedClassNames[singleClassName]){
return singleClassName;
}else{
style[prop]=value;
}
}
}).

join('\n').
trim();

var className='\n'+_className;

var props={
className:className,
style:(0,_prefixInlineStyles2.default)(style)};


if(process.env.__REACT_NATIVE_DEBUG_ENABLED__){
console.log('DOM props\n',props);
console.groupEnd();
}

return props;
};




var resolvePropsIfNeeded=function resolvePropsIfNeeded(key,style){
if(!key||!resolvedPropsCache[key]){

resolvedPropsCache[key]=resolveProps(style);
}
return resolvedPropsCache[key];
};




var StyleRegistry={
initialize:function initialize(){
var classNames=_injector2.default.getAvailableClassNames();
classNames.forEach(function(className){injectedClassNames[className]=true;});
},

reset:function reset(){
injectedClassNames={};
resolvedPropsCache={};
_injector2.default.reset();
},

register:function register(style){
var id=_ReactNativePropRegistry2.default.register(style);
return registerStyle(id,style);
},

resolve:function resolve(reactNativeStyle){
if(!reactNativeStyle){
return undefined;
}


if(typeof reactNativeStyle==='number'){
var key=''+prefix+reactNativeStyle;
return resolvePropsIfNeeded(key,reactNativeStyle);
}


if(!Array.isArray(reactNativeStyle)){
return resolveProps(reactNativeStyle);
}



var flatArray=(0,_flattenArray2.default)(reactNativeStyle);
var isArrayOfNumbers=true;
for(var i=0;i<flatArray.length;i++){
if(typeof flatArray[i]!=='number'){
isArrayOfNumbers=false;
break;
}
}

if(isArrayOfNumbers){

var _key=''+prefix+flatArray.join('-');
return resolvePropsIfNeeded(_key,flatArray);
}else{

return resolveProps(flatArray);
}
}};


module.exports=StyleRegistry;